package com.dynamsoft.ipcamera;


import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import static java.lang.Math.asin;
import static java.lang.Math.atan2;



public class Camere {

    //variables
    ArrayList<Camera> aCam=  new ArrayList<Camera>(100);//array of cameras
    char Enable=1; // 1 you can fill array with new data,0 not allowed because renderer use it,3 wait for new file

    public void ReadString(String line){

        String[] numbers = null;
        float cx,cy,cz,vx,vy,vz,vw;
        numbers = line.split("\\d\\s+");
        boolean IsNewFile;
        cx = Float.valueOf(numbers[1].trim());
        cy = Float.valueOf(numbers[2].trim());
        cz = Float.valueOf(numbers[3].trim());
        vx = Float.valueOf(numbers[4].trim());
        vy = Float.valueOf(numbers[5].trim());
        vz = Float.valueOf(numbers[6].trim());
        vw = Float.valueOf(numbers[7].trim());

        IsNewFile=(cx==0)&&(cy==0)&&(cz==0)&&(vx==0)&&(vy==0)&&(vz==0)&&(vw==1);

        if (IsNewFile&&(Enable==1)) {
            Enable=0;
            aCam.clear();
            aCam.add(new Camera(cx, cy, cz, vx, vy, vz, vw));//add camera
        }
        else if  ((!IsNewFile)&&(Enable==0))
            aCam.add(new Camera(cx, cy, cz, vx, vy, vz, vw));//add camera
        else if ((IsNewFile)&&(Enable==0)) {
            Enable=2;//PUOI FAR FARE IL RENDER
        }

    }
    //Constructor of camera
    public class Camera {

        public Camera(float x, float y, float z, float qx, float qy, float qz,float qw)//constructor
        {
            //y and z are inverted, 10 is a scale factor

            cx=x*10;
            cy=z*10;
            cz=0*10;//no altitude data on screen
            vx=qy;
            vy=qz;
            vz=qy;
            vw=qw;
            // roll (x-axis rotation)
            float sinr = +2.0f * (vw * vx + vy * vz);
            float cosr = +1.0f - 2.0f * (vx * vx + vy * vy);
            ax =(float) Math.toDegrees(atan2(sinr, cosr));


            // pitch (y-axis rotation)
            double sinp = +2.0 * (vw * vy - vz * vx);
            if (sinp>1)
                sinp=1;
            else if (sinp<1)
                sinp=-1;
            ay = (float) Math.toDegrees(asin(sinp));


            // yaw (z-axis rotation)
            double siny = +2.0 * (vw * vz + vx * vy);
            double cosy = +1.0 - 2.0 * (vy * vy + vz * vz);
            az = (float) Math.toDegrees(atan2(siny, cosy));

        }

        //variable
        float cx, cy, cz;//camera center
        float vx, vy, vz, vw;//camera quaternion
        float ax,ay,az;//camera angles roll pitch yaw

    }
}
