package com.dynamsoft.ipcamera;


import android.content.Context;
import android.opengl.GLSurfaceView;
import android.view.MotionEvent;


class MyGLSurfaceView extends GLSurfaceView {

    private final float TOUCH_SCALE_ZOOM=0.3f ;//0.3 is a scala factor for zooming, lower is slower.
    private float mPreviousX;
    private float mPreviousY;
    private boolean zoom = false;
    private float prev_sup_zoom=0;

    private final MyGLRenderer mRenderer;

    public MyGLSurfaceView(Context context){
        super(context);

        // Create an OpenGL ES 2.0 context
        setEGLContextClientVersion(2);

        mRenderer = new MyGLRenderer();

        // Set the Renderer for drawing on the GLSurfaceView
        setRenderer(mRenderer);
        // Render the view only when there is a change in the drawing data
        //setRenderMode(GLSurfaceView.RENDERMODE_WHEN_DIRTY);
    }


    public boolean onTouchEvent(MotionEvent e) {
        // MotionEvent reports input details from the touch screen
        // and other input controls. In this case, you are only
        // interested in events where the touch position changed.
        //x,y value of the touch
        float x = e.getX(0);
        float y = e.getY(0);
        float sup_zoom=0;

        switch (e.getAction()) {
            case MotionEvent.ACTION_MOVE:

                float dx = x - mPreviousX;
                float dy = y - mPreviousY;
                //check if tras
                // reverse direction of rotation above the mid-line

                if (e.getPointerCount()==1 ) {//if only one finger
                    if (zoom==true) {   //zoom is used when you use 2 fing and then 1 to cancel the previous dx and dy
                        zoom = false;
                        dx=0;
                        dy=0;
                    }

                }
                else if (e.getPointerCount()==2 )//if only 2 finger
                {

                    if (zoom==false)
                    {
                       zoom=true;
                       sup_zoom=0;
                       prev_sup_zoom=(e.getX(1)-x)*(e.getX(1)-x)  +(e.getY(1)-y)*(e.getY(1)-y);;
                    }
                    else
                    {
                        sup_zoom=(e.getX(1)-x)*(e.getX(1)-x)  +(e.getY(1)-y)*(e.getY(1)-y);
                        if (prev_sup_zoom>sup_zoom)//to know if it's zooming or not
                            mRenderer.setCamZ(TOUCH_SCALE_ZOOM);
                        else
                            mRenderer.setCamZ(-TOUCH_SCALE_ZOOM);
                        prev_sup_zoom= sup_zoom;
                    }

                }
                requestRender();//request to Render because there are changes in the view
        }

        mPreviousX = x;
        mPreviousY = y;
        return true;
    }
}